#include <stdio.h>
#include <unistd.h>
#include <dlfcn.h>
#include "fini.h"
#include "msg.h"

extern int lib_func (char *);

int main ()
{
    void *libHandle;
    int (* func) (const char *);
    void (* fini) (void);
    char buf[42];
    char *errTxt;
    sprintf (buf, "test string");

    if ((libHandle = dlopen ("libtest.so", RTLD_NOW)) == NULL)
   {
       fprintf (stderr, "dlopen failed\n");
       abort ();
   }

    dlerror ();
    /* Calling msginit() before dlopen() ends up with different values
       for the parent's thread_t, so do it here.  */
    msginit ();
    msg ("main:        called dlopen\n");

    msg ("main:        calling dlsym for lib_func\n");
    func = (int (*)(const char *)) dlsym (libHandle, "lib_func");
    if ((errTxt = dlerror ()) != NULL)
   {
       fprintf (stderr, "dlsym failed for lib_func\n");
       abort ();
   }

#ifdef DIRECT
    dlerror ();
    msg ("main:        calling dlsym for " CLEANUP_STR "\n");
    fini = (void (*)(void)) dlsym (libHandle, CLEANUP_STR);
    if ((errTxt = dlerror ()) != NULL)
   {
       fprintf (stderr, "dlsym failed for " CLEANUP_STR "\n");
       abort ();
   }
#endif

    msg ("main:        calling lib_func\n");
    (*func) (buf);
    msg ("main:        back, sleep(2)...\n");
    sleep (2);

#ifdef DIRECT
    msg ("main:        calling " CLEANUP_STR "\n");
    (*fini)();
#endif

    msg ("main:        calling dlclose\n");
    if (dlclose (libHandle) != 0)
   {
       fprintf (stderr, "dlclose failed\n");
       abort ();
   }

    msg ("main:        done\n");
    return 0;
}
