#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

pthread_mutex_t msglock = PTHREAD_MUTEX_INITIALIZER;
pthread_t parent;

void
msginit (void)
{
    parent = pthread_self ();
}

void
msg (const char *buf)
{
    int status;

    if ((status = pthread_mutex_lock (&msglock)) != 0)
   {
      fprintf (stderr, "pthread_mutex_unlock failed\n");
      abort ();
   }

    fprintf (stdout, "%s   %s",
        pthread_equal (pthread_self (), parent) ? "parent" : "child ", buf);
    fflush (stdout);

    if ((status = pthread_mutex_unlock (&msglock)) != 0)
   {
      fprintf (stderr, "pthread_mutex_unlock failed\n");
      abort ();
   }
}
