#include "test.h"
#include "msg.h"
#include <unistd.h>  // needed for older versions of glibc
#include <stdio.h>

pthread_t child_id = 0;

void *run_it(void *p)
{
    sleep(1); // avoid racing conditions on the log file

    msg ("run_it:      new thread\n");
    msg ("run_it:      sleep(3)...\n");
    sleep(3);
    msg ("run_it:      awake again\n");
    try
   {
       msg ("run_it:      throw (this might hang)\n");
       throw Exception();  // this one hangs forever
   }
    catch(...)
   {
       msg ("run_it:      caught it\n");
   }
    msg ("run_it:      return\n");
    return (void*)0;
}

extern "C" int lib_func ( char *arg1 )
{
    FILE* fi;
    char buf[42];
    int rc;

    sprintf (buf, "lib_func:    arg1=%s\n", arg1);
    msg (buf);
    rc = pthread_create(&child_id, NULL, run_it, 0);
    sprintf(buf, "lib_func:    thread created, rc=%i\n", rc);
    msg (buf);

    return 0;
}
